# HG changeset patch
# User Barbara Locsi <locsi.barbara@gmail.com>
# Date 1468493706 -7200
#      Thu Jul 14 12:55:06 2016 +0200
# Node ID c15c6f5a9d630c126f8af06394aa600738d00671
# Parent  4cb607691bb250bff3145148a102d45504a814d9
eig.cc: fix error messages, add tests

diff -r 4cb607691bb2 -r c15c6f5a9d63 libinterp/corefcn/eig.cc
--- a/libinterp/corefcn/eig.cc	Mon Jul 11 14:46:54 2016 +0200
+++ b/libinterp/corefcn/eig.cc	Thu Jul 14 12:55:06 2016 +0200
@@ -122,7 +122,10 @@ The eigenvalues returned by @code{eig} a
             err_wrong_type_arg ("eig", args(2));
           std::string a2s = args(2).string_value ();
           if (a2s != "balance" && a2s != "nobalance" && a2s!="vector" && a2s!="matrix")
-            error ("eig: unexpected fourth input: %s", a2s.c_str ());
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          std::string a3s = args(3).string_value ();
+          if (a3s != "balance" && a3s != "nobalance" && a3s!="vector" && a3s!="matrix")
+            error ("eig: unexpected fourth input: %s", a3s.c_str ());
         }
 
     }
@@ -163,7 +166,7 @@ The eigenvalues returned by @code{eig} a
             err_wrong_type_arg ("eig", args(3));
           std::string a3s = args(3).string_value ();
           if (a3s != "chol" && a3s != "qz" && a3s!="vector" && a3s!="matrix")
-            error ("eig: unexpected third input: %s", a3s.c_str ());
+            error ("eig: unexpected fourth input: %s", a3s.c_str ());
           
           force_qz = a2s == "qz" || a3s == "qz";
           v_flag = a2s == "vector" || a3s == "vector";
@@ -1108,6 +1111,8 @@ The eigenvalues returned by @code{eig} a
 %!error <wrong type argument> eig (false, [1 2 ; 2 3])
 %!error <eig: unexpected third input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], "abcd")
 %!error <eig: unexpected third input: qz> eig ([1 2 ; 2 3], 'balance', 'qz')
+%!error <eig: unexpected fourth input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], 'vector', 'abcd')
+%!error <eig: unexpected fourth input: abcd> eig ([1 2 ; 2 3], 'balance', 'matrix', 'abcd')
 %!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'balance', 'nobalance')
 %!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'nobalance', 'balance')
 %!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'matrix', 'vector')
@@ -1117,4 +1122,4 @@ The eigenvalues returned by @code{eig} a
 %!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], false)
 %!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], [1 2 ; 2 3])
 
-*/
\ No newline at end of file
+*/

